【POJ - 2135 】【最小费用最大流】【裸】【1-n-1不重复路的最小值】

2023-10-20 04:38

本文主要是介绍【POJ - 2135 】【最小费用最大流】【裸】【1-n-1不重复路的最小值】,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

http://poj.org/problem?id=2135

【题意】

求1->n->1不重复路的最短路

【题解】最小费用最大流的模板题

               最小费用最大流-->多次s'p'fa-->满足最大情况下,用spfa找可行流的最短路径

               建图:源点s:0,汇点t:n+1

               1.add(s,1,2(流量),0(费用))

               2.add(n,t,2,0)

               3.add(u,v,1,0)

                  add(v,u,1,0)

【代码】

#include<iostream>
#include <algorithm>
#include<cstdio>
#include<cstring>
#include<queue>
#include<vector>
using namespace std;
typedef long long ll;
const int INF = 100000000;
const int N = 1005;
struct edge
{int from, to, cap, flow, cost;edge(int u, int v, int c, int f, int co) :from(u), to(v), cap(c), flow(f), cost(co) {}
};
struct MCMF
{int n, m;vector<edge>edges;vector<int>g[N];int inq[N];int d[N];int p[N];int a[N];void init(int n) {this->n = n;for (int i = 0; i <= n; i++)g[i].clear();edges.clear();}void addedge(int from, int to, int cap, int cost) {edges.push_back(edge(from, to, cap, 0, cost));edges.push_back(edge(to, from, 0, 0, -cost));m = edges.size();g[from].push_back(m - 2);g[to].push_back(m - 1);}bool spfa(int s, int t, int &flow, int &cost) {for (int i = 0; i <= n; i++)d[i] = INF;memset(inq, 0, sizeof(inq));d[s] = 0; inq[s] = 1; p[s] = 0; a[s] = INF;queue<int>q;q.push(s);while (!q.empty()) {int u = q.front(); q.pop();inq[u] = 0;for (int i = 0; i<g[u].size(); i++) {edge &e = edges[g[u][i]];if (e.cap>e.flow&&d[e.to]>d[u] + e.cost) {d[e.to] = d[u] + e.cost;p[e.to] = g[u][i];a[e.to] = min(a[u], e.cap - e.flow);if (!inq[e.to]) { q.push(e.to); inq[e.to] = 1; }}}}if (d[t] == INF)return 0;flow += a[t];cost += d[t] * a[t];for (int u = t; u != s; u = edges[p[u]].from) {edges[p[u]].flow += a[t];edges[p[u] ^ 1].flow -= a[t];}return 1;}int MincoatMaxflow(int s, int t, int& cost) {int flow = 0; cost = 0;while (spfa(s, t, flow, cost));return flow;}
};
int main()
{int m, n;MCMF mcmf;scanf("%d%d", &n, &m);mcmf.init(n + 1);while (m--) {int u, v, w;scanf("%d%d%d", &u, &v, &w);mcmf.addedge(u, v, 1, w);mcmf.addedge(v, u, 1, w);}mcmf.addedge(0, 1, 2, 0);mcmf.addedge(n, n + 1, 2, 0);n++;int cost = 0;int ans = mcmf.MincoatMaxflow(0, n, cost);cout << cost << endl;
}

 

这篇关于【POJ - 2135 】【最小费用最大流】【裸】【1-n-1不重复路的最小值】的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/244710

相关文章

Oracle数据库使用 listagg去重删除重复数据的方法汇总

《Oracle数据库使用listagg去重删除重复数据的方法汇总》文章介绍了在Oracle数据库中使用LISTAGG和XMLAGG函数进行字符串聚合并去重的方法,包括去重聚合、使用XML解析和CLO... 目录案例表第一种:使用wm_concat() + distinct去重聚合第二种:使用listagg,

MySQL中删除重复数据SQL的三种写法

《MySQL中删除重复数据SQL的三种写法》:本文主要介绍MySQL中删除重复数据SQL的三种写法,文中通过代码示例讲解的非常详细,对大家的学习或工作有一定的帮助,需要的朋友可以参考下... 目录方法一:使用 left join + 子查询删除重复数据(推荐)方法二:创建临时表(需分多步执行,逻辑清晰,但会

如何提高Redis服务器的最大打开文件数限制

《如何提高Redis服务器的最大打开文件数限制》文章讨论了如何提高Redis服务器的最大打开文件数限制,以支持高并发服务,本文给大家介绍的非常详细,感兴趣的朋友跟随小编一起看看吧... 目录如何提高Redis服务器的最大打开文件数限制问题诊断解决步骤1. 修改系统级别的限制2. 为Redis进程特别设置限制

poj2406(连续重复子串)

题意:判断串s是不是str^n,求str的最大长度。 解题思路:kmp可解,后缀数组的倍增算法超时。next[i]表示在第i位匹配失败后,自动跳转到next[i],所以1到next[n]这个串 等于 n-next[n]+1到n这个串。 代码如下; #include<iostream>#include<algorithm>#include<stdio.h>#include<math.

poj3261(可重复k次的最长子串)

题意:可重复k次的最长子串 解题思路:求所有区间[x,x+k-1]中的最小值的最大值。求sa时间复杂度Nlog(N),求最值时间复杂度N*N,但实际复杂度很低。题目数据也比较水,不然估计过不了。 代码入下: #include<iostream>#include<algorithm>#include<stdio.h>#include<math.h>#include<cstring

poj 3974 and hdu 3068 最长回文串的O(n)解法(Manacher算法)

求一段字符串中的最长回文串。 因为数据量比较大,用原来的O(n^2)会爆。 小白上的O(n^2)解法代码:TLE啦~ #include<stdio.h>#include<string.h>const int Maxn = 1000000;char s[Maxn];int main(){char e[] = {"END"};while(scanf("%s", s) != EO

hdu 2602 and poj 3624(01背包)

01背包的模板题。 hdu2602代码: #include<stdio.h>#include<string.h>const int MaxN = 1001;int max(int a, int b){return a > b ? a : b;}int w[MaxN];int v[MaxN];int dp[MaxN];int main(){int T;int N, V;s

poj 1511 Invitation Cards(spfa最短路)

题意是给你点与点之间的距离,求来回到点1的最短路中的边权和。 因为边很大,不能用原来的dijkstra什么的,所以用spfa来做。并且注意要用long long int 来存储。 稍微改了一下学长的模板。 stack stl 实现代码: #include<stdio.h>#include<stack>using namespace std;const int M

poj 3259 uva 558 Wormholes(bellman最短路负权回路判断)

poj 3259: 题意:John的农场里n块地,m条路连接两块地,w个虫洞,虫洞是一条单向路,不但会把你传送到目的地,而且时间会倒退Ts。 任务是求你会不会在从某块地出发后又回来,看到了离开之前的自己。 判断树中是否存在负权回路就ok了。 bellman代码: #include<stdio.h>const int MaxN = 501;//农场数const int

poj 1258 Agri-Net(最小生成树模板代码)

感觉用这题来当模板更适合。 题意就是给你邻接矩阵求最小生成树啦。~ prim代码:效率很高。172k...0ms。 #include<stdio.h>#include<algorithm>using namespace std;const int MaxN = 101;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int n